

MatMinors_Alt := function(mat)
    local k, l, q;
    k := Length(mat[1]);
    l := Length(mat);
    return List(Combinations([1..l], k), x -> Determinant(mat{x}));
end;

MatMinors  := function( mat )
    local n, l, s, m, i, S, M, k, a, j, b, w, h, r;

    # set up
    n := Length(mat[1]);
    l := Length(mat);

    # init
    s := List([1..l], x -> [x]);
    m := List([1..l], x -> mat[x][1]);
 
    # loop
    for i in [2..n] do
        S := [];
        M := [];
        for k in [1..Length(s)] do
            for j in [s[k][i-1]+1..l] do
                b := ShallowCopy(s[k]); b[i] := j;
                w := mat[j][i] * m[k];
                for h in [1..i-1] do
                    if mat[b[h]][i] <> 0 * mat[b[h]][i] then 
                        r := Concatenation(b{[1..h-1]}, b{[h+1..i]});
                        r := Position( s, r );
                        w := w + (-1)^(h+i) * mat[b[h]][i] * m[r];
                    fi;
                od;
                Add(S, b);
                Add(M, w);
            od;
        od;
        s := StructuralCopy(S);
        m := StructuralCopy(M);
    od;
                
    return m;
end;

MatMinorsPlus  := function( mat )
    local n, l, s, m, i, S, M, k, a, j, b, w, h, r;

    # set up
    n := Length(mat[1]);
    l := Length(mat);

    # init
    s := List([1..l], x -> [x]);
    m := List([1..l], x -> mat[x][1]);
 
    # loop
    for i in [2..n] do
        S := [];
        M := [];
        for k in [1..Length(s)] do
            for j in [s[k][i-1]+1..l] do
                b := ShallowCopy(s[k]); b[i] := j;
                w := mat[j][i] * m[k];
                for h in [1..i-1] do
                    if mat[b[h]][i] <> 0 * mat[b[h]][i] then 
                        r := Concatenation(b{[1..h-1]}, b{[h+1..i]});
                        r := Position( s, r );
                        w := w + (-1)^(h+i) * mat[b[h]][i] * m[r];
                    fi;
                od;
                Add(S, b);
                Add(M, w);
            od;
        od;
        s := StructuralCopy(S);
        m := StructuralCopy(M);
    od;
                
    return rec( minors := m, sets := s);
end;


