#############################################################################
##
#F PartitionChange( <part> )
##
#   Example: Given [3, 0, 2, 0, 0, 0, 0, 0, 0]  this function 
#   computes [3, 3, 1, 1, 1].
#
PartitionChange := function( part )
    local new, i;
    new := [];
    for i in Reversed([1..Length(part)]) do
        if part[i] > 0 then  
            Append(new, List([1..part[i]], x -> i));
        fi;
    od;
    return new;
end;

#############################################################################
##
#F PartitionChangeBack( <part> )
##
#   reverse PartitionChange
#
PartitionChangeBack := function( part )
    local new, i;
    new := List( [1..Sum(part)], x -> 0);
    for i in [1..Length(part)] do
        if part[i] <> 0 then 
            new[part[i]] := new[part[i]]+1;
        fi;
    od;
    return new;
end;

#############################################################################
##
#F PartitionSum( <p1>, <p2> )
##
PartitionSum := function( p1, p2 )
    return p1+p2;
end;

#############################################################################
##
#F PartitionCountNumber( <part> )
##
PartitionCountNumber := function( part )
    return Sum( List( [1..Length(part)], x -> x*part[x]));
end;

#############################################################################
##
#F PartitionFillInZeroes( <part> )
##
PartitionFillInZeroes := function( part )
    local n;
    n := PartitionCountNumber(part);
    return List( [1..n], x -> 0 ) + part;
end;

#############################################################################
##
#F PartitionCutOffZeroes( <part> )
##
PartitionCutOffZeroes := function( part )
    local i;
    for i in Reversed([1..Length(part)]) do
        if part[i] <> 0 then 
            return part{[1..i]};
        fi;
    od;
    return [];
end;

